"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const data_api_local_1 = require("data-api-local");
class DataAPILocalServerless {
    constructor(serverless) {
        this.serverless = serverless;
        this.hooks = {
            'before:offline:start:init': this.startHandler.bind(this),
            'before:offline:start:end': this.endHandler.bind(this)
        };
    }
    get config() {
        return this.serverless.service.custom['data-api-local'] || {};
    }
    startHandler() {
        return __awaiter(this, void 0, void 0, function* () {
            this.server = yield data_api_local_1.dataApiLocal(this.config);
        });
    }
    endHandler() {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.server.stop();
        });
    }
}
exports.DataAPILocalServerless = DataAPILocalServerless;
//# sourceMappingURL=DataAPILocalServerless.js.map